//	*******************************************************************************
//	Name	:	glut_cb.hxx
//			:	callback GLUT
//	Author	:	I. Nakagawa
//	Create	:	2019/10/23
//	Modify	:	2019/10/24		
//	*******************************************************************************

#pragma		once

#include	<cstdlib>
//#ifdef  	__APPLE_CC__
//#include	<GLUT/glut.h>
//#else
#include	<GL/glut.h>
//#endif

////
//	*******************************************************************************
//	init
//	Create	:	2019/10/23
//	*******************************************************************************
inline	void	cb_init	(float r=1,float g=1,float b=1,float a=1)
{
	::glClearColor(r,g,b,a) ;
	::glEnable(GL_DEPTH_TEST) ;
	}

////
//	*******************************************************************************
//	init
//	Create	:	2019/10/24
//	*******************************************************************************
inline	void	cl_init	(float r=1,float g=1,float b=1,float a=1)
{
	::cb_init(r,g,b,a) ;
	::glEnable(GL_LIGHTING) ;
	::glEnable(GL_LIGHT0) ;
	}

////
//	*******************************************************************************
//	keyboard
//	Create	:	2019/10/23
//	*******************************************************************************
inline	void	cb_keyboard	(unsigned char key,int x,int y)
{
	switch (key) {
		case	'q' :
		case	'Q' :
		case	'\x1b' :
			::exit(0) ;
			break ;
		default	:
			break ;
		}
	}

////
//	*******************************************************************************
//	idle
//	Create	:	2019/10/23
//	*******************************************************************************
inline	void	cb_idle	(void)
{
	::glutPostRedisplay() ;
	}

////
//	*******************************************************************************
//	resize
//	Create	:	2019/10/23
//	Modify	:	2019/10/31
//	*******************************************************************************
inline	void	Perspective	(double zFar=1000.,double zNear=1.,double fovy=30.)
{
	double	w = ::glutGet(GLUT_WINDOW_WIDTH) ;
	double	h = ::glutGet(GLUT_WINDOW_HEIGHT);
	::gluPerspective(fovy,double(w)/double(h),zNear,zFar) ;
	}

inline	void	cb_resize	(int w,int h)
{
	::glViewport(0,0,w,h) ;
	::glMatrixMode(GL_PROJECTION) ;
	::glLoadIdentity() ;
	double	ratio = 1.0 ;
	if (w <= h)		{	ratio = 1.*h/w ;	::glOrtho(-0,w,-0*ratio,w*ratio,-100.,100.) ;	}
	else			{	ratio = 1.*w/h ;	::glOrtho(-0*ratio,h*ratio,-0,h,-100.,100.) ;	}
//	::Perspective() ;
	}

////
//	*******************************************************************************
//	timer
//	Create	:	2019/10/28
//	*******************************************************************************
inline	void	cb_timer	(int value)
{
	::glutPostRedisplay() ;
	}

////
//	*******************************************************************************
//	display
//	Create	:	2019/10/24
//	*******************************************************************************
inline	void	cs_draw	(void)
{
	::glColor3d(1,0,0) ;
	{
		::glBegin(GL_LINE_LOOP) ;
		::glVertex3d(  10,  10, 0) ;
		::glVertex3d( 400,  10, 0) ;
		::glVertex3d( 400, 300, 0) ;
		::glVertex3d(  10, 300, 0) ;
		::glEnd() ;
		}
	::glColor3d(0.5,0.5,0) ;
	{
		::glBegin(GL_LINE_LOOP) ;
		::glVertex3d( 30, 20,  0) ;
		::glVertex3d(250, 20,  0) ;
		::glVertex3d(250,350,  0) ;
		::glVertex3d( 30,350,  0) ;
		::glEnd() ;
		}
	::glColor3d(0,0,1) ;
	{
		::glBegin(GL_LINE_LOOP) ;
		::glVertex3d( 200, 200, 0) ;
		::glVertex3d( 100, 200, 0) ;
		::glVertex3d( 100, 100, 0) ;
		::glVertex3d( 200, 100, 0) ;
		::glEnd() ;
		}
	::glFlush() ;
	}

////
//	*******************************************************************************
//	display
//	Create	:	2019/10/31
//	*******************************************************************************
inline	void	cb_display	(void)
{
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
	::cs_draw() ;
	::glutSwapBuffers() ;
	}

////
//	*******************************************************************************
//	mouse
//	Create	:	2019/10/31
//	*******************************************************************************
inline	void	cs_mouse	(int button,int state,int x,int y)
{
	static	int	x0 = 0 ;
	static	int	y0 = 0 ;
	int		height	= ::glutGet(GLUT_WINDOW_HEIGHT);
	int		x1 = x ;
	int		y1 = height - y ;
	switch (button)	{
		case	GLUT_LEFT_BUTTON	:
			if (state == GLUT_DOWN)	{
				x0 = x1 ;
				y0 = y1 ;
				}
			else {
				::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
				::cs_draw() ;
				::glColor3d(0,0,0) ;
				::glBegin(GL_LINES) ;
				::glVertex2i(x0,y0) ;
				::glVertex2i(x1,y1) ;
				::glEnd() ;
				::glFlush() ;
				::glutSwapBuffers() ;
				}
			break;
		default:
			break;
		}
	}

