//	*******************************************************************************
//	Name	:	i_raddeg.hxx
//			:	rad , deg
//	Author	:	I. Nakagawa
//	Create	:	2014/09/02
//	Modify	:	2017/03/015 Add Revise_...
//	*******************************************************************************

#pragma		once

#ifdef	M_PI
	#define	PI			M_PI
#else
	#define	PI			0.314159265358979323846e+01
#endif

inline	double	deg(const double r)	{	return	(r*180.0/PI) ;	}
inline	double	rad(const double d)	{	return	(d*PI/180.0) ;	}

////
//	*******************************************************************************
//	define	sin and cos
//	Create	:	2017/03/15
//	*******************************************************************************
struct	SinCos	{
	SinCos	(double v=0)			: s(v) ,	c(v)	{	}
	SinCos	(double s_, double c_)	: s(s_),	c(c_)	{	}
	double	s ;
	double	c ;
	} ;

////
//	*******************************************************************************
//	revise	sin and cos
//	Create	:	2017/03/15
//	*******************************************************************************
inline	SinCos	Revise_rad	(const double theta,const SinCos sc_)
{
	SinCos	sc = sc_ ;
	if		(theta == rad(   0))	{	sc.s = 0 ;		sc.c = 1 ;		}
	else if	(theta == rad(  90))	{	sc.s = 1 ;		sc.c = 0 ;		}
	else if	(theta == rad(-270))	{	sc.s = 1 ;		sc.c = 0 ;		}
	else if	(theta == rad( 180))	{	sc.s = 0 ;		sc.c =-1 ;		}
	else if	(theta == rad(-180))	{	sc.s = 0 ;		sc.c =-1 ;		}
	else if	(theta == rad( 270))	{	sc.s =-1 ;		sc.c = 0 ;		}
	else if	(theta == rad( -90))	{	sc.s =-1 ;		sc.c = 0 ;		}
	else if	(theta == rad( 360))	{	sc.s = 0 ;		sc.c = 1 ;		}
	else if	(theta == rad(-360))	{	sc.s = 0 ;		sc.c = 1 ;		}
	else if	(theta == rad(  30))	{	sc.s = 0.5 ;					}
	else if	(theta == rad(-330))	{	sc.s = 0.5 ;					}
	else if	(theta == rad( 150))	{	sc.s = 0.5 ;					}
	else if	(theta == rad(-210))	{	sc.s = 0.5 ;					}
	else if	(theta == rad( 210))	{	sc.s =-0.5 ;					}
	else if	(theta == rad(-150))	{	sc.s =-0.5 ;					}
	else if	(theta == rad( 330))	{	sc.s =-0.5 ;					}
	else if	(theta == rad( -30))	{	sc.s =-0.5 ;					}
	else if	(theta == rad(  60))	{					sc.c = 0.5 ;	}
	else if	(theta == rad(-300))	{					sc.c = 0.5 ;	}
	else if	(theta == rad( 120))	{					sc.c =-0.5 ;	}
	else if	(theta == rad(-240))	{					sc.c =-0.5 ;	}
	else if	(theta == rad( 240))	{					sc.c =-0.5 ;	}
	else if	(theta == rad(-120))	{					sc.c =-0.5 ;	}
	else if	(theta == rad( 300))	{					sc.c = 0.5 ;	}
	else if	(theta == rad( -60))	{					sc.c = 0.5 ;	}
	return	sc ;
	}

inline	SinCos	Revise_deg	(const long deg_,SinCos sc_)
{
	long	theta = (deg_ % 360) ;
	SinCos	sc = sc_ ;
	if		(theta ==   0)			{	sc.s = 0 ;		sc.c = 1 ;		}
	else if	(theta ==  90)			{	sc.s = 1 ;		sc.c = 0 ;		}
	else if	(theta ==-270)			{	sc.s = 1 ;		sc.c = 0 ;		}
	else if	(theta == 180)			{	sc.s = 0 ;		sc.c =-1 ;		}
	else if	(theta ==-180)			{	sc.s = 0 ;		sc.c =-1 ;		}
	else if	(theta == 270)			{	sc.s =-1 ;		sc.c = 0 ;		}
	else if	(theta == -90)			{	sc.s =-1 ;		sc.c = 0 ;		}
	else if	(theta == 360)			{	sc.s = 0 ;		sc.c = 1 ;		}
	else if	(theta ==-360)			{	sc.s = 0 ;		sc.c = 1 ;		}
	else if	(theta ==  30)			{	sc.s = 0.5 ;					}
	else if	(theta ==-330)			{	sc.s = 0.5 ;					}
	else if	(theta == 150)			{	sc.s = 0.5 ;					}
	else if	(theta ==-210)			{	sc.s = 0.5 ;					}
	else if	(theta == 210)			{	sc.s =-0.5 ;					}
	else if	(theta ==-150)			{	sc.s =-0.5 ;					}
	else if	(theta == 330)			{	sc.s =-0.5 ;					}
	else if	(theta == -30)			{	sc.s =-0.5 ;					}
	else if	(theta ==  60)			{					sc.c = 0.5 ;	}
	else if	(theta ==-300)			{					sc.c = 0.5 ;	}
	else if	(theta == 120)			{					sc.c =-0.5 ;	}
	else if	(theta ==-240)			{					sc.c =-0.5 ;	}
	else if	(theta == 240)			{					sc.c =-0.5 ;	}
	else if	(theta ==-120)			{					sc.c =-0.5 ;	}
	else if	(theta == 300)			{					sc.c = 0.5 ;	}
	else if	(theta == -60)			{					sc.c = 0.5 ;	}
	return	sc ;
	}

